import getpass;
import sys;
import paramiko;
import time;
import re;
from io import StringIO;

class OnepointSSH:
    def __init__(self, do_echo = False, do_verbose = False):
        self.ssh = None;
        self.channel = None;
        self.sshtasksteps = [];
        self.do_echo = do_echo;
        self.do_verbose = do_verbose;
        self.sio_stdout = StringIO()
        self.sio_stderr = StringIO()
        self.sio_ssh_output = StringIO();
        self.timeout = 10;
        self.waittime = .5;
    @staticmethod
    def getinstance():
        return OnepointSSH();
    def logevent(self, s):
        print(s);
    def hello(self):
        print("Hello, World!");
    def getTimeout(self):
        return self.timeout;
    def setTimeout(self, timeout):
        self.timeout = timeout;
    def getWaitTime(self):
        return self.waittime;
    def setWaitTime(self, waittime):
        self.waittime = waittime;
    def ssh_local(self, port = 22, username = None, password = None, key_filename = None):
        host = 'localhost';
        if username is None:
            username = getpass.getuser();
        self.ssh = paramiko.SSHClient();
        self.ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy());
        try:
            if password is None and key_filename is None:
                self.ssh.connect(hostname=host, port=port, username=username, timeout=self.timeout); #, key_filename='/home/pedrofmj/.ssh/id_rsa'
            elif password is None and key_filename is not None:
                self.ssh.connect(hostname=host, port=port, username=username, timeout=self.timeout, key_filename=key_filename);
            elif password is not None and key_filename is None:
                self.ssh.connect(hostname=host, port=port, username=username, password=password, timeout=self.timeout);
            else:
                self.ssh.connect(hostname=host, port=port, username=username, password=password, timeout=self.timeout, key_filename=key_filename);
            return self.ssh;
        except Exception as ex:
            print("An exception of type {0} occurred. Arguments:\n{1}".format(type(ex).__name__, ex.args))
            self.token = None;
            return self.token;
    def ssh_create(self, host = 'localhost', port = 22, username = None, password = None):
        if username is None:
            username = getpass.getuser();
        self.ssh = paramiko.SSHClient();
        self.ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy());
        try:
            if password is None:
                self.ssh.connect(hostname=host, port=port, username=username, timeout=self.timeout); #, key_filename='/home/pedrofmj/.ssh/id_rsa'
            else:
                self.ssh.connect(hostname=host, port=port, username=username, password=password, timeout=self.timeout);
            return self.ssh;
        except Exception as ex:
            #print("An exception of type {0} occurred. Arguments:\n{1}".format(type(ex).__name__, ex.args))
            self.token = None;
            raise ex
            return self.token;
    def ssh_execute_command(self, command):
        stdin, stdout, stderr = self.ssh.exec_command(command);
        llines = stdout.readlines();
        slines = ''.join(llines);
        #self.logevent(slines);
        return slines;
    def ssh_execute_command_2(self, command):
        stdin, stdout, stderr = self.ssh.exec_command(command);
        llines = stderr.readlines();
        slines = ''.join(llines);
        #self.logevent(slines);
        return slines;
    def ssh_create_shell(self):
        self.channel = self.ssh.invoke_shell();
    def ssh_execute_command_on_shell(self, command):
        self.channel.send(command + '\n');
        #while not self.channel.recv_ready():
        #time.sleep(3);
        time.sleep(.5);
        out = self.recvall(self.channel);
        return out;
    def ssh_close(self):
        self.ssh.close();
    def recvall(self, sock, n = -1):
        data = '';
        if n >= 0:
            while len(data) < n:
                if not sock.recv_ready():
                    time.sleep(self.waittime);
                    if not sock.recv_ready():
                        time.sleep(self.waittime);
                        if not sock.recv_ready():
                            time.sleep(self.waittime);
                            if not sock.recv_ready():
                                time.sleep(self.waittime);
                                if not sock.recv_ready():
                                    time.sleep(self.waittime);
                                    if not sock.recv_ready():
                                        break;
                packet = sock.recv(n - len(data));
                if not packet or len(packet) == 0 or packet == "":
                    break;
                data += packet;
        else:
            while True:
                if not sock.recv_ready():
                    time.sleep(self.waittime);
                    if not sock.recv_ready():
                        time.sleep(self.waittime);
                        if not sock.recv_ready():
                            time.sleep(self.waittime);
                            if not sock.recv_ready():
                                time.sleep(self.waittime);
                                if not sock.recv_ready():
                                    time.sleep(self.waittime);
                                    if not sock.recv_ready():
                                        break;
                packet = sock.recv(1);
                if not packet or len(packet) == 0 or packet == "":
                    break;
                data += "".join(map(chr, packet));
        return data;
    def ssh_task_clear_steps(self):
        self.sshtasksteps = []
    def ssh_task_add_step(self, constraint, command):
        step = {
            'constraint': constraint,
            'command': command
        };
        self.sshtasksteps.append(step);
    def ssh_task_execute(self):
        lastoutput = None;
        llen = len(self.sshtasksteps);
        if llen >= 1:
            i = 0;
            while i < llen:
                if self.do_verbose:
                    sys.stderr.write('Step {0} - Initiating: Testing\n'.format(i));
                    sys.stderr.write('Step {0} - Constraint: {1}\n'.format(i, self.sshtasksteps[i]['constraint']));
                    sys.stderr.write('Step {0} - Output:\n{1}\n'.format(i, lastoutput));
                ismatch = False;
                #compiledconstraint = re.compile(self.sshtasksteps[i]['constraint'], re.MULTILINE);
                if lastoutput is None:
                    ismatch = True;
                elif re.search(self.sshtasksteps[i]['constraint'], lastoutput) is not None:
                    ismatch = True;
                if ismatch:
                    if self.do_verbose:
                        sys.stderr.write('Step {0} - Constraint Match Success\n'.format(i));
                        sys.stderr.write('Step {0} - Executing Command: {1}\n'.format(i, self.sshtasksteps[i]['command']));
                    lastoutput = self.ssh_execute_command_on_shell(self.sshtasksteps[i]['command']);
                    self.sio_ssh_output.write(lastoutput);
                    if self.do_echo:
                        sys.stdout.write(lastoutput);
                else:
                    if self.do_verbose:
                        sys.stderr.write('Step {0} - Constraint Match Error\n'.format(i));
                    return i;
                i += 1;
        return llen;
    def ssh_get_output(self):
        return self.sio_ssh_output.getvalue();
