from onepoint.ssh import OnepointSSH
import subprocess

class IReportUtil:
    def __init__(self, key_filename = None):
        self.key_filename = key_filename
        pass
    def test_ssh(self, address, username, password):
        ossh = OnepointSSH()
        oclient = ossh.ssh_create(address, 22, username, password)
        if oclient is not None:
            ossh.ssh_close()
            return True
        else:
            return False
    def accountreport_unix(self, address, port, username, password):
        try:
            ossh = OnepointSSH()
            ossh.ssh_create(address, port, username, password)
            ossh.setTimeout(4)
            print('aaaa')
            soutput = ossh.ssh_execute_command('echo - - - - - - {; (cat /etc/passwd | grep -v /sbin/nologin | cut -d: -f1,3); echo - - - - - - }')
            asoutput = soutput.splitlines();
            isinside = False;
            users = [];
            for i in range(0, len(asoutput)):
                sline = asoutput[i];
                if sline == '- - - - - - {':
                    isinside = True;
                elif sline == '- - - - - - }':
                    isinside = False;
                elif isinside and sline != '':
                    aline = sline.split(':')
                    suser = aline[0]
                    stype = 'normal'
                    if aline[1] == '0':
                        stype = 'privileged'
                    users.append({ 'username': suser, 'type': stype, 'groups': [], 'passwordlastset': '', 'expires': '' })
                else:
                    pass
            for user in users:
                soutput_usergroups = ossh.ssh_execute_command("groups \"{0}\" | cut -d: -f 2 | tail -c +2 | tr \" \" \"\\n\"".format(user['username']))
                asoutput_usergroups = soutput_usergroups.splitlines()
                user['groups'].extend(asoutput_usergroups)
                soutput_passwordinfo = ossh.ssh_execute_command("chage -l -i ftp | head -2 | cut -d: -f 2 | cut -c 2-");
                asoutput_passwordinfo = soutput_passwordinfo.splitlines()
                user['passwordlastset'] = asoutput_passwordinfo[0]
                user['expires'] = asoutput_passwordinfo[1]
            return users
        except Exception as e:
            return str(e)
    def accountreport_unix_withsteps(self, address, port, username, password):
        try:
            commandslimit = 1
            ossh = OnepointSSH()
            ossh.ssh_create(address, port, username, password)
            ossh.ssh_create_shell()
            ossh.ssh_task_add_step('', 'echo - - - - - - {; (cat /etc/passwd | grep -v /sbin/nologin | cut -d: -f1,3); echo - - - - - - }');
            stoppedatstep = ossh.ssh_task_execute();
            if stoppedatstep != commandslimit:
                return False
            soutput = ossh.ssh_get_output();
            asoutput = soutput.splitlines();
            isinside = False;
            users = [];
            for i in range(0, len(asoutput)):
                sline = asoutput[i];
                if sline == '- - - - - - {':
                    isinside = True;
                elif sline == '- - - - - - }':
                    isinside = False;
                elif isinside and sline != '':
                    aline = sline.split(':')
                    suser = aline[0]
                    stype = 'normal'
                    if aline[1] == '0':
                        stype = 'privileged'
                    users.append({ 'username': suser, 'type': stype });
                else:
                    pass;	
            return users
        except Exception as e:
            return str(e)
    def accountreport_windows(self, address, username, password):
        try:
            #print(['cscript', '/nologo', 'listaccounts.vbs', address, username, password])
            result = subprocess.run(['cscript', '/nologo', 'listaccounts.vbs', address, username, password], stdout=subprocess.PIPE)
            output = result.stdout
            output = output.decode('utf-8')
            aoutput = output.splitlines()
            users = []
            for sline in aoutput:
                aline = sline.split(';')
                suser = aline[0]
                stype = aline[1]
                spasswordlastset = aline[2]
                sexpires = aline[3]
                sgroups = aline[4]
                agroups = sgroups.split(',')
                users.append({ 'username': suser, 'type': stype, 'groups': agroups, 'passwordlastset': spasswordlastset, 'expires': sexpires })
            return users
        except Exception as e:
            return str(e)
    def changepwd_unix(self, address, username, password, targetuser, newpassword):
        try:
            ossh = OnepointSSH()
            commandslimit = 4
            ossh.ssh_create(address, 22, username, password)
            ossh.ssh_create_shell()
            ossh.ssh_task_add_step('', 'sudo passwd ' + targetuser)
            #if not password is None:
            #    ossh.ssh_task_add_step('', password)
            #    commandslimit = commandslimit + 1
            ossh.ssh_task_add_step('.*(password|senha):.*', newpassword)
            ossh.ssh_task_add_step('.*(password|senha):.*', newpassword)
            ossh.ssh_task_add_step('.*:.*', 'echo')
            stoppedatstep = ossh.ssh_task_execute()
            if stoppedatstep == commandslimit:
                return True
            else:
                return False
        except:
            return False
    def changepwd_windows(self, address, username, password, targetuser, newpassword):
        try:
            ossh = OnepointSSH()
            ossh.ssh_local(key_filename=self.key_filename)
            ossh.ssh_create_shell()
            ossh.ssh_task_add_step(".*[\$#].*", "echo");
            ossh.ssh_task_add_step(".*", "net rpc user password \"{0}\" --server=\"{1}\" --user=\"{2}\" && echo SUCCESS".format(targetuser, address, username));
            ossh.ssh_task_add_step(".*password.*", newpassword);
            ossh.ssh_task_add_step(".*password.*", password);
            ossh.ssh_task_add_step(".*SUCCESS.*", "");
            stoppedatstep = ossh.ssh_task_execute()
            if stoppedatstep == 5:
                return True
            else:
                return False
        except:
            return False
